package info.yeppp.ebuilda.filesystem;

import info.yeppp.ebuilda.Machine;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;

public class FileSystem {

	public static void copyFile(AbsoluteFilePath destinationPath, AbsoluteFilePath sourcePath) throws IOException {
		if (destinationPath.getMachine() == Machine.getLocal() && sourcePath.getMachine() == Machine.getLocal()) {
			final File sourceFile = new File(sourcePath.getCanonicalForm());
			final File destinationFile = new File(destinationPath.getCanonicalForm());
			if (!destinationFile.exists()) {
				destinationFile.createNewFile();
			}
			FileChannel sourceChannel = new FileInputStream(sourceFile).getChannel();
			FileChannel destinationChannel = new FileOutputStream(destinationFile, false).getChannel();
			destinationChannel.transferFrom(sourceChannel, 0, sourceChannel.size());
		} else {
			throw new Error("Remote connection is not supported yet");
		}
	}


}
