/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See LICENSE.txt for the full text of the license.
 */

#include <jni.h>
#include <yepPrivate.h>
#include <yepCore.h>
#include <yepJavaPrivate.h>


JNIEXPORT jbyte JNICALL Java_info_yeppp_Core_Min_1V8s_1S8s(JNIEnv *env, jclass class, jbyteArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep8s* vPointer = NULL;
	Yep8s minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jbyte)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jbyte)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jbyte)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jbyte)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V8s_S8s(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jbyte JNICALL Java_info_yeppp_Core_Min_1V8u_1S8u(JNIEnv *env, jclass class, jbyteArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep8u* vPointer = NULL;
	Yep8u minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jbyte)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jbyte)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jbyte)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jbyte)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V8u_S8u(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jshort JNICALL Java_info_yeppp_Core_Min_1V16s_1S16s(JNIEnv *env, jclass class, jshortArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep16s* vPointer = NULL;
	Yep16s minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jshort)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jshort)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jshort)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jshort)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V16s_S16s(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jshort JNICALL Java_info_yeppp_Core_Min_1V16u_1S16u(JNIEnv *env, jclass class, jshortArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep16u* vPointer = NULL;
	Yep16u minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jshort)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jshort)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jshort)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jshort)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V16u_S16u(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jint JNICALL Java_info_yeppp_Core_Min_1V32s_1S32s(JNIEnv *env, jclass class, jintArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep32s* vPointer = NULL;
	Yep32s minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jint)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jint)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jint)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jint)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V32s_S32s(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jint JNICALL Java_info_yeppp_Core_Min_1V32u_1S32u(JNIEnv *env, jclass class, jintArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep32u* vPointer = NULL;
	Yep32u minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jint)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jint)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jint)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jint)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V32u_S32u(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jlong JNICALL Java_info_yeppp_Core_Min_1V64s_1S64s(JNIEnv *env, jclass class, jlongArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep64s* vPointer = NULL;
	Yep64s minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jlong)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jlong)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jlong)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jlong)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V64s_S64s(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jlong JNICALL Java_info_yeppp_Core_Min_1V64u_1S64u(JNIEnv *env, jclass class, jlongArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep64u* vPointer = NULL;
	Yep64u minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jlong)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jlong)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jlong)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jlong)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V64u_S64u(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jfloat JNICALL Java_info_yeppp_Core_Min_1V32f_1S32f(JNIEnv *env, jclass class, jfloatArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep32f* vPointer = NULL;
	Yep32f minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jfloat)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jfloat)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jfloat)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jfloat)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V32f_S32f(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT jdouble JNICALL Java_info_yeppp_Core_Min_1V64f_1S64f(JNIEnv *env, jclass class, jdoubleArray vArray, jint vOffset, jint length) {
	enum YepStatus status;
	Yep64f* vPointer = NULL;
	Yep64f minimum;

	if YEP_UNLIKELY(vArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument vArray is null");
		return (jdouble)0;
	}
	if YEP_UNLIKELY(vOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument vOffset is negative");
		return (jdouble)0;
	}
	if YEP_UNLIKELY(((YepSize)vOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, vArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "vOffset + length exceed the length of vArray");
		return (jdouble)0;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return (jdouble)0;
	}

	vPointer = (*env)->GetPrimitiveArrayCritical(env, vArray, NULL);

	status = yepCore_Min_V64f_S64f(&vPointer[vOffset], &minimum, length);

	(*env)->ReleasePrimitiveArrayCritical(env, vArray, vPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}


	return minimum;
}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V8sV8s_1V8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jbyteArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* yPointer = NULL;
	Yep8s* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V8sV8s_V8s(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V8uV8u_1V8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jbyteArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* yPointer = NULL;
	Yep8u* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V8uV8u_V8u(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V16sV16s_1V16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jshortArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* yPointer = NULL;
	Yep16s* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V16sV16s_V16s(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V16uV16u_1V16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jshortArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* yPointer = NULL;
	Yep16u* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V16uV16u_V16u(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V32sV32s_1V32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jintArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* yPointer = NULL;
	Yep32s* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V32sV32s_V32s(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V32uV32u_1V32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jintArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* yPointer = NULL;
	Yep32u* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V32uV32u_V32u(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V64sV32s_1V64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jintArray yArray, jint yOffset, jlongArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;
	Yep32s* yPointer = NULL;
	Yep64s* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V64sV32s_V64s(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V64uV32u_1V64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jintArray yArray, jint yOffset, jlongArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;
	Yep32u* yPointer = NULL;
	Yep64u* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V64uV32u_V64u(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V32fV32f_1V32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jfloatArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;
	Yep32f* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V32fV32f_V32f(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V64fV64f_1V64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jdoubleArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;
	Yep64f* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V64fV64f_V64f(&xPointer[xOffset], &yPointer[yOffset], &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V8sS8s_1V8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jbyteArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V8sS8s_V8s(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V8uS8u_1V8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jbyteArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V8uS8u_V8u(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V16sS16s_1V16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jshortArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V16sS16s_V16s(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V16uS16u_1V16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jshortArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V16uS16u_V16u(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V32sS32s_1V32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jintArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V32sS32s_V32s(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V32uS32u_1V32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jintArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V32uS32u_V32u(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V64sS32s_1V64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jint y, jlongArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;
	Yep64s* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V64sS32s_V64s(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V64uS32u_1V64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jint y, jlongArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;
	Yep64u* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V64uS32u_V64u(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V32fS32f_1V32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloat y, jfloatArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V32fS32f_V32f(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1V64fS64f_1V64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdouble y, jdoubleArray minimumArray, jint minimumOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* minimumPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(minimumArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument minimumArray is null");
		return;
	}
	if YEP_UNLIKELY(minimumOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument minimumOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)minimumOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, minimumArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "minimumOffset + length exceed the length of minimumArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	minimumPointer = (*env)->GetPrimitiveArrayCritical(env, minimumArray, NULL);

	status = yepCore_Min_V64fS64f_V64f(&xPointer[xOffset], y, &minimumPointer[minimumOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, minimumArray, minimumPointer, 0);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, JNI_ABORT);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV8sV8s_1IV8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;
	Yep8s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV8sV8s_IV8s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV8uV8u_1IV8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyteArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;
	Yep8u* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV8uV8u_IV8u(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV16sV16s_1IV16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;
	Yep16s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV16sV16s_IV16s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV16uV16u_1IV16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshortArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;
	Yep16u* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV16uV16u_IV16u(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV32sV32s_1IV32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;
	Yep32s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV32sV32s_IV32s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV32uV32u_1IV32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jintArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;
	Yep32u* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV32uV32u_IV32u(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV64sV32s_1IV64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jintArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;
	Yep32s* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV64sV32s_IV64s(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV64uV32u_1IV64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jintArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;
	Yep32u* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV64uV32u_IV64u(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV32fV32f_1IV32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloatArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;
	Yep32f* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV32fV32f_IV32f(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV64fV64f_1IV64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdoubleArray yArray, jint yOffset, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;
	Yep64f* yPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(yArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument yArray is null");
		return;
	}
	if YEP_UNLIKELY(yOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument yOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)yOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, yArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "yOffset + length exceed the length of yArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);
	yPointer = (*env)->GetPrimitiveArrayCritical(env, yArray, NULL);

	status = yepCore_Min_IV64fV64f_IV64f(&xPointer[xOffset], &yPointer[yOffset], length);

	(*env)->ReleasePrimitiveArrayCritical(env, yArray, yPointer, JNI_ABORT);
	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV8sS8s_1IV8s(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jint length) {
	enum YepStatus status;
	Yep8s* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV8sS8s_IV8s(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV8uS8u_1IV8u(JNIEnv *env, jclass class, jbyteArray xArray, jint xOffset, jbyte y, jint length) {
	enum YepStatus status;
	Yep8u* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV8uS8u_IV8u(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV16sS16s_1IV16s(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jint length) {
	enum YepStatus status;
	Yep16s* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV16sS16s_IV16s(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV16uS16u_1IV16u(JNIEnv *env, jclass class, jshortArray xArray, jint xOffset, jshort y, jint length) {
	enum YepStatus status;
	Yep16u* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV16uS16u_IV16u(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV32sS32s_1IV32s(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jint length) {
	enum YepStatus status;
	Yep32s* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV32sS32s_IV32s(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV32uS32u_1IV32u(JNIEnv *env, jclass class, jintArray xArray, jint xOffset, jint y, jint length) {
	enum YepStatus status;
	Yep32u* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV32uS32u_IV32u(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV64sS32s_1IV64s(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jint y, jint length) {
	enum YepStatus status;
	Yep64s* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV64sS32s_IV64s(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV64uS32u_1IV64u(JNIEnv *env, jclass class, jlongArray xArray, jint xOffset, jint y, jint length) {
	enum YepStatus status;
	Yep64u* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV64uS32u_IV64u(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV32fS32f_1IV32f(JNIEnv *env, jclass class, jfloatArray xArray, jint xOffset, jfloat y, jint length) {
	enum YepStatus status;
	Yep32f* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV32fS32f_IV32f(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}

JNIEXPORT void JNICALL Java_info_yeppp_Core_Min_1IV64fS64f_1IV64f(JNIEnv *env, jclass class, jdoubleArray xArray, jint xOffset, jdouble y, jint length) {
	enum YepStatus status;
	Yep64f* xPointer = NULL;

	if YEP_UNLIKELY(xArray == NULL) {
		(*env)->ThrowNew(env, NullPointerException, "Argument xArray is null");
		return;
	}
	if YEP_UNLIKELY(xOffset < 0) {
		(*env)->ThrowNew(env, IllegalArgumentException, "Argument xOffset is negative");
		return;
	}
	if YEP_UNLIKELY(((YepSize)xOffset) + ((YepSize)length) > (YepSize)((*env)->GetArrayLength(env, xArray))) {
		(*env)->ThrowNew(env, IndexOutOfBoundsException, "xOffset + length exceed the length of xArray");
		return;
	}
	if YEP_UNLIKELY(length < 0) {
		(*env)->ThrowNew(env, NegativeArraySizeException, "Argument length is negative");
		return;
	}

	xPointer = (*env)->GetPrimitiveArrayCritical(env, xArray, NULL);

	status = yepCore_Min_IV64fS64f_IV64f(&xPointer[xOffset], y, length);

	(*env)->ReleasePrimitiveArrayCritical(env, xArray, xPointer, 0);
	if YEP_UNLIKELY(status != YepStatusOk) {
		yepJNI_ThrowSuitableException(env, status);
	}

}
